<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <!-- Popper Development version -->
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="roleSelect" class="form-control"></select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead class="thead-dark">
        <tr>
          <th scope='col'>STT</th>
          <th scope='col'>Username</th>
          <th scope='col'>First name</th>
          <th scope='col'>Last name</th>
          <th scope='col'>Email</th>
          <th scope='col'>Age</th>
          <th scope='col'>Role</th>
          <th scope='col'>Action</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>
</body> 
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gSTT = 1
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];
     var gUSER_COL = ["stt","username","firstname","lastname","age","email","roleId","action"]
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
       const gVoucherTable = $("#user-table")
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
  var gNameCol = [
  "stt",
  "username",
  "firstname",
  "lastname",
  "email",
  "age",
  "roleId",
  "action"
];
const gSTT_COL = 0;
const gUSER_NAME_COL = 1;
const gFIRST_NAME_COL = 2;
const gLAST_NAME_COL = 3;
const gEMAIL_COL = 4;
const gAGE_COL = 5;
const gROLE_COL = 6;
const gACTION_COL = 7;
function mappingRoleNameByID(paramData, paramType, paramRow) {
  for (let bI = 0; bI < gRoleObjects.length; bI++) {
    const bRoleObjItem = gRoleObjects[bI];
    if (paramData == bRoleObjItem.roleId) {
      return bRoleObjItem.roleName;
    }
  }
}

function loadDataToRoleSelect() {
  var vRoleSelect = $("#roleSelect");
  $("<option/>", {
    text: "--- Chọn tất cả ---",
    value: 0
  }).appendTo(vRoleSelect);

  for (let bI = 0; bI < gRoleObjects.length; bI++) {
    var bPizzaTypeOption = $("<option/>", {
      text: gRoleObjects[bI].roleName,
      value: gRoleObjects[bI].roleId
    }).appendTo(vRoleSelect);
  }
}
function showTableUserDataTable() {
  console.log(gUserObjects);
  $("#user-table").DataTable({
    data: gUserObjects,
    columns: [
      { data: gNameCol[gSTT_COL] },
      { data: gNameCol[gUSER_NAME_COL] },
      { data: gNameCol[gFIRST_NAME_COL] },
      { data: gNameCol[gLAST_NAME_COL] },
      { data: gNameCol[gEMAIL_COL] },
      { data: gNameCol[gAGE_COL] },
      { data: gNameCol[gROLE_COL] },
      { data: gNameCol[gACTION_COL] }
    ], // Các thuộc tính của USER sẽ  match với từng column
    columnDefs: [
      //định nghĩa các cột cần hiện ra
      {
        targets: gSTT_COL, //cột STT
        className: "text-center text-primary",
        render: function (data, type, row, meta) {
          return meta.row + meta.settings._iDisplayStart + 1;
        }
      },
      {
        targets: gROLE_COL,
        className: "text-right",
        render: mappingRoleNameByID
      },
      {
        targets: gACTION_COL, //cột Action
        className: "text-center",
        defaultContent: `
            <button class="btn btn-dice" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
            <button class="btn btn-pire btn-sm" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`
      }
    ]
  });
}
function onPageLoading() {
  loadDataToRoleSelect();
  showTableUserDataTable();
  $('[data-toggle="tooltip"]').tooltip();
};
    // hàm dựa vào button detail (edit or delete) xác định đc id voucher
    function getVoucherIdFromButton(paramElement) {
      var vRowClick = $(paramElement).closest("tr"); // Xác định tr chứa nút bấm được click
  var vTable = $('#user-table').DataTable(); // tạo biện truy xuất đến datatable
  var vDataRow = vTable.row( vRowClick ).data(); // Lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
        var vUrlSiteToOpen = "show dice history table.html"+ "?id=" +vDataRow.id +"&username="+vDataRow.username
                                                                                 +"&firstname="+ vDataRow.firstname
                                                                                 +"&lastname="+ vDataRow.lastname
        window.location.href = vUrlSiteToOpen;
    return vDataRow
  }
$(document).ready(function () {
  onPageLoading();
     // gán sự kiện cho nút diec
     $("#user-table").on( 'click',".btn-dice",function() {
      getVoucherIdFromButton(this)
     })
});
</script>
</html>